package b4a.CustomKeyboardSample3;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.CustomKeyboardSample3", "b4a.CustomKeyboardSample3.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.CustomKeyboardSample3", "b4a.CustomKeyboardSample3.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.CustomKeyboardSample3.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.Timer _v6 = null;
public static int _type_text_flag_no_suggestions = 0;
public static boolean _v0 = false;
public anywheresoftware.b4a.objects.EditTextWrapper _etcust = null;
public bm.watscho.keyboard.CustomKeyboard _v5 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnchangest = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnchangekb = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnshowpv = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnenhapfb = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnsetshifted = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnchangekey = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
String _startkeyboard = "";
 //BA.debugLineNum = 40;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 52;BA.debugLine="Activity.LoadLayout(\"ckbtest\")";
mostCurrent._activity.LoadLayout("ckbtest",mostCurrent.activityBA);
 //BA.debugLineNum = 53;BA.debugLine="etCust.InputType = Bit.OR(etCust.InputType,TYPE_T";
mostCurrent._etcust.setInputType(anywheresoftware.b4a.keywords.Common.Bit.Or(mostCurrent._etcust.getInputType(),_type_text_flag_no_suggestions));
 //BA.debugLineNum = 54;BA.debugLine="etCust.SingleLine = False";
mostCurrent._etcust.setSingleLine(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 57;BA.debugLine="Dim StartKeyboard As String = \"ipkeyboard\"";
_startkeyboard = "ipkeyboard";
 //BA.debugLineNum = 58;BA.debugLine="Try";
try { //BA.debugLineNum = 59;BA.debugLine="CustKeyBoard.Initialize(\"CKB\", \"keyboardview_tra";
mostCurrent._v5.Initialize(mostCurrent.activityBA,"CKB","keyboardview_trans");
 //BA.debugLineNum = 60;BA.debugLine="CustKeyBoard.RegisterEditText(etCust, \"etCustD\",";
mostCurrent._v5.RegisterEditText((android.widget.EditText)(mostCurrent._etcust.getObject()),"etCustD",_startkeyboard,anywheresoftware.b4a.keywords.Common.True);
 } 
       catch (Exception e24) {
			processBA.setLastException(e24); //BA.debugLineNum = 62;BA.debugLine="Msgbox(\"There was an error in the 'Initialize/Re";
anywheresoftware.b4a.keywords.Common.Msgbox("There was an error in the 'Initialize/Register' method of the CustomKeyboard-library. Most probably a missing xml-file(misspelling?)","CUSTOMKEYBOARD-ERROR",mostCurrent.activityBA);
 //BA.debugLineNum = 63;BA.debugLine="Activity.Finish";
mostCurrent._activity.Finish();
 };
 //BA.debugLineNum = 65;BA.debugLine="UpdateTimer.Initialize(\"ButtonUpdate\",50)";
_v6.Initialize(processBA,"ButtonUpdate",(long) (50));
 //BA.debugLineNum = 66;BA.debugLine="UpdateTimer.Enabled = True";
_v6.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 67;BA.debugLine="SetEditTextParams(StartKeyboard)";
_v7(_startkeyboard);
 //BA.debugLineNum = 68;BA.debugLine="End Sub";
return "";
}
public static boolean  _activity_keypress(int _keycode) throws Exception{
 //BA.debugLineNum = 82;BA.debugLine="Sub Activity_KeyPress (KeyCode As Int) As Boolean";
 //BA.debugLineNum = 83;BA.debugLine="If KeyCode = KeyCodes.KEYCODE_BACK Then";
if (_keycode==anywheresoftware.b4a.keywords.Common.KeyCodes.KEYCODE_BACK) { 
 //BA.debugLineNum = 84;BA.debugLine="If CustKeyBoard.IsSoftKeyboardVisible Then";
if (mostCurrent._v5.IsSoftKeyboardVisible()) { 
 //BA.debugLineNum = 85;BA.debugLine="If CustKeyBoard.HandleBack Then Return True";
if (mostCurrent._v5.HandleBack()) { 
if (true) return anywheresoftware.b4a.keywords.Common.True;};
 //BA.debugLineNum = 86;BA.debugLine="CustKeyBoard.HideKeyboard";
mostCurrent._v5.HideKeyboard();
 //BA.debugLineNum = 87;BA.debugLine="Return True";
if (true) return anywheresoftware.b4a.keywords.Common.True;
 };
 };
 //BA.debugLineNum = 90;BA.debugLine="Return False";
if (true) return anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 91;BA.debugLine="End Sub";
return false;
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 78;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 80;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 70;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 72;BA.debugLine="If Not(CustKeyBoard.IsOScompatible) Then";
if (anywheresoftware.b4a.keywords.Common.Not(mostCurrent._v5.IsOScompatible())) { 
 //BA.debugLineNum = 73;BA.debugLine="Msgbox(\"!!! This app needs at least APILEVEL 15,";
anywheresoftware.b4a.keywords.Common.Msgbox("!!! This app needs at least APILEVEL 15, the app ends now !!! ","CKBTEST-FAIL",mostCurrent.activityBA);
 //BA.debugLineNum = 74;BA.debugLine="Activity.Finish";
mostCurrent._activity.Finish();
 };
 //BA.debugLineNum = 76;BA.debugLine="End Sub";
return "";
}
public static String  _btnchangekb_click() throws Exception{
String _newkeyboard = "";
 //BA.debugLineNum = 110;BA.debugLine="Sub btnChangeKb_Click";
 //BA.debugLineNum = 111;BA.debugLine="Dim NewKeyboard As String";
_newkeyboard = "";
 //BA.debugLineNum = 113;BA.debugLine="btnSetShifted.Enabled = False";
mostCurrent._btnsetshifted.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 114;BA.debugLine="btnChangeKey.Enabled = False";
mostCurrent._btnchangekey.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 115;BA.debugLine="Select Case CustKeyBoard.GetRegisteredStatus(etCu";
switch (BA.switchObjectToInt(mostCurrent._v5.GetRegisteredStatus((android.widget.EditText)(mostCurrent._etcust.getObject())),"ipkeyboard","fullnrkeyboard","hexkeyboardshift","popkeyboard","standard","neverregistered")) {
case 0:
 //BA.debugLineNum = 117;BA.debugLine="NewKeyboard = \"fullnrkeyboard\"";
_newkeyboard = "fullnrkeyboard";
 break;
case 1:
 //BA.debugLineNum = 119;BA.debugLine="NewKeyboard = \"hexkeyboardshift\"";
_newkeyboard = "hexkeyboardshift";
 //BA.debugLineNum = 120;BA.debugLine="btnSetShifted.Enabled = True";
mostCurrent._btnsetshifted.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 121;BA.debugLine="btnChangeKey.Enabled = True";
mostCurrent._btnchangekey.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 break;
case 2:
 //BA.debugLineNum = 123;BA.debugLine="NewKeyboard = \"popkeyboard\"";
_newkeyboard = "popkeyboard";
 break;
case 3:
 //BA.debugLineNum = 125;BA.debugLine="NewKeyboard = \"standard\"";
_newkeyboard = "standard";
 break;
case 4:
 //BA.debugLineNum = 127;BA.debugLine="NewKeyboard = \"ipkeyboard\"";
_newkeyboard = "ipkeyboard";
 break;
case 5:
 //BA.debugLineNum = 129;BA.debugLine="NewKeyboard = \"neverregistered\"";
_newkeyboard = "neverregistered";
 break;
}
;
 //BA.debugLineNum = 131;BA.debugLine="Select Case NewKeyboard";
switch (BA.switchObjectToInt(_newkeyboard,"neverregistered")) {
case 0:
 break;
default:
 //BA.debugLineNum = 134;BA.debugLine="Try";
try { //BA.debugLineNum = 135;BA.debugLine="CustKeyBoard.ChangeKeyboardLayout(etCust,NewKe";
mostCurrent._v5.ChangeKeyboardLayout((android.widget.EditText)(mostCurrent._etcust.getObject()),_newkeyboard);
 } 
       catch (Exception e91) {
			processBA.setLastException(e91); //BA.debugLineNum = 137;BA.debugLine="Msgbox(\"There was an error in the 'ChangeKeybo";
anywheresoftware.b4a.keywords.Common.Msgbox("There was an error in the 'ChangeKeyboardLayout' method of the CustomKeyboard-library. Most probably a missing xml-file(misspelling?)","CUSTOMKEYBOARD-ERROR",mostCurrent.activityBA);
 //BA.debugLineNum = 138;BA.debugLine="Activity.Finish";
mostCurrent._activity.Finish();
 };
 break;
}
;
 //BA.debugLineNum = 141;BA.debugLine="KbKeyChanged = False";
_v0 = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 142;BA.debugLine="SetEditTextParams(NewKeyboard)";
_v7(_newkeyboard);
 //BA.debugLineNum = 143;BA.debugLine="End Sub";
return "";
}
public static String  _btnchangekey_click() throws Exception{
int[] _newkeycodes = null;
 //BA.debugLineNum = 188;BA.debugLine="Sub btnChangeKey_Click";
 //BA.debugLineNum = 189;BA.debugLine="Dim NewKeyCodes(1) As Int";
_newkeycodes = new int[(int) (1)];
;
 //BA.debugLineNum = 190;BA.debugLine="If KbKeyChanged Then";
if (_v0) { 
 //BA.debugLineNum = 191;BA.debugLine="NewKeyCodes(0) =  -3";
_newkeycodes[(int) (0)] = (int) (-3);
 //BA.debugLineNum = 192;BA.debugLine="Try";
try { //BA.debugLineNum = 193;BA.debugLine="CustKeyBoard.ChangeKeyValues(\"sym_keyboard_retu";
mostCurrent._v5.ChangeKeyValues("sym_keyboard_return",anywheresoftware.b4a.keywords.Common.True,"DONE",anywheresoftware.b4a.keywords.Common.False,_newkeycodes);
 } 
       catch (Exception e144) {
			processBA.setLastException(e144); //BA.debugLineNum = 195;BA.debugLine="Msgbox(\"There was an error in the 'ChangeKeyVal";
anywheresoftware.b4a.keywords.Common.Msgbox("There was an error in the 'ChangeKeyValues' method of the CustomKeyboard-library. Most probably a missing icon-file(misspelling?) or wrong combination of 'XXXLabel' and 'IsIcon'","CUSTOMKEYBOARD-ERROR",mostCurrent.activityBA);
 //BA.debugLineNum = 196;BA.debugLine="Activity.Finish";
mostCurrent._activity.Finish();
 };
 //BA.debugLineNum = 198;BA.debugLine="KbKeyChanged = False";
_v0 = anywheresoftware.b4a.keywords.Common.False;
 }else {
 //BA.debugLineNum = 200;BA.debugLine="NewKeyCodes(0) =  -4";
_newkeycodes[(int) (0)] = (int) (-4);
 //BA.debugLineNum = 201;BA.debugLine="Try";
try { //BA.debugLineNum = 202;BA.debugLine="CustKeyBoard.ChangeKeyValues(\"DONE\",False,\"sym_";
mostCurrent._v5.ChangeKeyValues("DONE",anywheresoftware.b4a.keywords.Common.False,"sym_keyboard_return",anywheresoftware.b4a.keywords.Common.True,_newkeycodes);
 } 
       catch (Exception e153) {
			processBA.setLastException(e153); //BA.debugLineNum = 204;BA.debugLine="Msgbox(\"There was an error in the 'ChangeKeyVal";
anywheresoftware.b4a.keywords.Common.Msgbox("There was an error in the 'ChangeKeyValues' method of the CustomKeyboard-library. Most probably a missing icon-file(misspelling?) or wrong combination of 'XXXLabel' and 'IsIcon'","CUSTOMKEYBOARD-ERROR",mostCurrent.activityBA);
 //BA.debugLineNum = 205;BA.debugLine="Activity.Finish";
mostCurrent._activity.Finish();
 };
 //BA.debugLineNum = 207;BA.debugLine="KbKeyChanged = True";
_v0 = anywheresoftware.b4a.keywords.Common.True;
 };
 //BA.debugLineNum = 209;BA.debugLine="End Sub";
return "";
}
public static String  _btnchangest_click() throws Exception{
String _newkeyboardstyle = "";
 //BA.debugLineNum = 145;BA.debugLine="Sub btnChangeSt_Click";
 //BA.debugLineNum = 146;BA.debugLine="Dim NewKeyboardStyle As String";
_newkeyboardstyle = "";
 //BA.debugLineNum = 147;BA.debugLine="Select Case CustKeyBoard.GetCurKeyboardStyle";
switch (BA.switchObjectToInt(mostCurrent._v5.GetCurKeyboardStyle(),"keyboardview_ics","keyboardview_trans","keyboardview_fulltrans")) {
case 0:
 //BA.debugLineNum = 149;BA.debugLine="NewKeyboardStyle = \"keyboardview_trans\"";
_newkeyboardstyle = "keyboardview_trans";
 break;
case 1:
 //BA.debugLineNum = 151;BA.debugLine="NewKeyboardStyle = \"keyboardview_fulltrans\"";
_newkeyboardstyle = "keyboardview_fulltrans";
 break;
case 2:
 //BA.debugLineNum = 153;BA.debugLine="NewKeyboardStyle = \"keyboardview_ics\"";
_newkeyboardstyle = "keyboardview_ics";
 break;
}
;
 //BA.debugLineNum = 155;BA.debugLine="Try";
try { //BA.debugLineNum = 156;BA.debugLine="CustKeyBoard.ChangeKeyboardStyle(NewKeyboardStyl";
mostCurrent._v5.ChangeKeyboardStyle(_newkeyboardstyle);
 } 
       catch (Exception e111) {
			processBA.setLastException(e111); //BA.debugLineNum = 158;BA.debugLine="Msgbox(\"There was an error in the 'ChangeKeyboar";
anywheresoftware.b4a.keywords.Common.Msgbox("There was an error in the 'ChangeKeyboardStyle' method of the CustomKeyboard-library. Most probably a missing xml-file(misspelling?)","CUSTOMKEYBOARD-ERROR",mostCurrent.activityBA);
 //BA.debugLineNum = 159;BA.debugLine="Activity.Finish";
mostCurrent._activity.Finish();
 };
 //BA.debugLineNum = 161;BA.debugLine="KbKeyChanged = False";
_v0 = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 162;BA.debugLine="End Sub";
return "";
}
public static String  _btnenhapfb_click() throws Exception{
 //BA.debugLineNum = 172;BA.debugLine="Sub btnEnHapFb_Click";
 //BA.debugLineNum = 173;BA.debugLine="If CustKeyBoard.IsHapticFeedbackEnabled Then";
if (mostCurrent._v5.IsHapticFeedbackEnabled()) { 
 //BA.debugLineNum = 174;BA.debugLine="CustKeyBoard.SetHapticFeedbackEnabled(False)";
mostCurrent._v5.SetHapticFeedbackEnabled(anywheresoftware.b4a.keywords.Common.False);
 }else {
 //BA.debugLineNum = 176;BA.debugLine="CustKeyBoard.SetHapticFeedbackEnabled(True)";
mostCurrent._v5.SetHapticFeedbackEnabled(anywheresoftware.b4a.keywords.Common.True);
 };
 //BA.debugLineNum = 178;BA.debugLine="End Sub";
return "";
}
public static String  _btnsetshifted_click() throws Exception{
 //BA.debugLineNum = 180;BA.debugLine="Sub btnSetShifted_Click";
 //BA.debugLineNum = 181;BA.debugLine="If CustKeyBoard.IsShifted Then";
if (mostCurrent._v5.IsShifted()) { 
 //BA.debugLineNum = 182;BA.debugLine="CustKeyBoard.SetShifted(False)";
mostCurrent._v5.SetShifted(anywheresoftware.b4a.keywords.Common.False);
 }else {
 //BA.debugLineNum = 184;BA.debugLine="CustKeyBoard.SetShifted(True)";
mostCurrent._v5.SetShifted(anywheresoftware.b4a.keywords.Common.True);
 };
 //BA.debugLineNum = 186;BA.debugLine="End Sub";
return "";
}
public static String  _btnshowpv_click() throws Exception{
 //BA.debugLineNum = 164;BA.debugLine="Sub btnShowPv_Click";
 //BA.debugLineNum = 165;BA.debugLine="If CustKeyBoard.IsPreviewEnabled Then";
if (mostCurrent._v5.IsPreviewEnabled()) { 
 //BA.debugLineNum = 166;BA.debugLine="CustKeyBoard.ShowPreviewPopup(False)";
mostCurrent._v5.ShowPreviewPopup(anywheresoftware.b4a.keywords.Common.False);
 }else {
 //BA.debugLineNum = 168;BA.debugLine="CustKeyBoard.ShowPreviewPopup(True)";
mostCurrent._v5.ShowPreviewPopup(anywheresoftware.b4a.keywords.Common.True);
 };
 //BA.debugLineNum = 170;BA.debugLine="End Sub";
return "";
}
public static String  _buttonupdate_tick() throws Exception{
 //BA.debugLineNum = 211;BA.debugLine="Sub ButtonUpdate_Tick";
 //BA.debugLineNum = 212;BA.debugLine="If CustKeyBoard.IsPreviewEnabled Then";
if (mostCurrent._v5.IsPreviewEnabled()) { 
 //BA.debugLineNum = 213;BA.debugLine="btnShowPv.Text = \"HIDE-PREVIEW\"";
mostCurrent._btnshowpv.setText((Object)("HIDE-PREVIEW"));
 }else {
 //BA.debugLineNum = 215;BA.debugLine="btnShowPv.Text = \"SHOW-PREVIEW\"";
mostCurrent._btnshowpv.setText((Object)("SHOW-PREVIEW"));
 };
 //BA.debugLineNum = 217;BA.debugLine="If CustKeyBoard.IsHapticFeedbackEnabled Then";
if (mostCurrent._v5.IsHapticFeedbackEnabled()) { 
 //BA.debugLineNum = 218;BA.debugLine="btnEnHapFb.Text = \"HAPTIC-FB-OFF\"";
mostCurrent._btnenhapfb.setText((Object)("HAPTIC-FB-OFF"));
 }else {
 //BA.debugLineNum = 220;BA.debugLine="btnEnHapFb.Text = \"HAPTIC-FB-ON\"";
mostCurrent._btnenhapfb.setText((Object)("HAPTIC-FB-ON"));
 };
 //BA.debugLineNum = 222;BA.debugLine="If CustKeyBoard.IsShifted Then";
if (mostCurrent._v5.IsShifted()) { 
 //BA.debugLineNum = 223;BA.debugLine="btnSetShifted.Text = \"SET-UNSHIFTED\"";
mostCurrent._btnsetshifted.setText((Object)("SET-UNSHIFTED"));
 }else {
 //BA.debugLineNum = 225;BA.debugLine="btnSetShifted.Text = \"SET-SHIFTED\"";
mostCurrent._btnsetshifted.setText((Object)("SET-SHIFTED"));
 };
 //BA.debugLineNum = 227;BA.debugLine="End Sub";
return "";
}
public static String  _ckb_heightchanged(int _newheight,int _oldheight) throws Exception{
 //BA.debugLineNum = 229;BA.debugLine="Sub CKB_HeightChanged(NewHeight As Int, OldHeight";
 //BA.debugLineNum = 234;BA.debugLine="CallSubDelayed3(Me,\"SetEditTextHeight\",NewHeight,";
anywheresoftware.b4a.keywords.Common.CallSubDelayed3(mostCurrent.activityBA,main.getObject(),"SetEditTextHeight",(Object)(_newheight),(Object)(_oldheight));
 //BA.debugLineNum = 235;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 26;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 30;BA.debugLine="Dim etCust As EditText";
mostCurrent._etcust = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 31;BA.debugLine="Dim CustKeyBoard As CustomKeyboard";
mostCurrent._v5 = new bm.watscho.keyboard.CustomKeyboard();
 //BA.debugLineNum = 32;BA.debugLine="Dim btnChangeSt As Button";
mostCurrent._btnchangest = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 33;BA.debugLine="Dim btnChangeKb As Button";
mostCurrent._btnchangekb = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 34;BA.debugLine="Dim btnShowPv As Button";
mostCurrent._btnshowpv = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 35;BA.debugLine="Dim btnEnHapFb As Button";
mostCurrent._btnenhapfb = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 36;BA.debugLine="Dim btnSetShifted As Button";
mostCurrent._btnsetshifted = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 37;BA.debugLine="Dim btnChangeKey As Button";
mostCurrent._btnchangekey = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 38;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 17;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 21;BA.debugLine="Dim UpdateTimer As Timer";
_v6 = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 22;BA.debugLine="Dim TYPE_TEXT_FLAG_NO_SUGGESTIONS  As Int = 0x800";
_type_text_flag_no_suggestions = (int) (0x80000);
 //BA.debugLineNum = 23;BA.debugLine="Dim KbKeyChanged As Boolean = False";
_v0 = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 24;BA.debugLine="End Sub";
return "";
}
public static String  _setedittextheight(int _newheight,int _oldheight) throws Exception{
 //BA.debugLineNum = 237;BA.debugLine="Sub SetEditTextHeight(NewHeight As Int, OldHeight";
 //BA.debugLineNum = 238;BA.debugLine="If NewHeight < OldHeight Then";
if (_newheight<_oldheight) { 
 //BA.debugLineNum = 239;BA.debugLine="etCust.Height = NewHeight - (etCust.Top + 10dip)";
mostCurrent._etcust.setHeight((int) (_newheight-(mostCurrent._etcust.getTop()+anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (10)))));
 }else if(_newheight>_oldheight) { 
 //BA.debugLineNum = 241;BA.debugLine="etCust.Height = 60%y";
mostCurrent._etcust.setHeight(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (60),mostCurrent.activityBA));
 };
 //BA.debugLineNum = 243;BA.debugLine="End Sub";
return "";
}
public static String  _v7(String _startkeyboard) throws Exception{
 //BA.debugLineNum = 93;BA.debugLine="Sub SetEditTextParams(StartKeyboard As String)";
 //BA.debugLineNum = 94;BA.debugLine="Select Case StartKeyboard";
switch (BA.switchObjectToInt(_startkeyboard,"ipkeyboard","fullnrkeyboard","hexkeyboardshift","popkeyboard","standard","neverregistered")) {
case 0:
 //BA.debugLineNum = 96;BA.debugLine="etCust.Text = \"The editbox now accepts only dec";
mostCurrent._etcust.setText((Object)("The editbox now accepts only decimal numbers & the dot & delete & four cursor keys"));
 break;
case 1:
 //BA.debugLineNum = 98;BA.debugLine="etCust.Text = \"The editbox now accepts only dec";
mostCurrent._etcust.setText((Object)("The editbox now accepts only decimal numbers & delete & CRLF & six cursor keys & space & clear"));
 break;
case 2:
 //BA.debugLineNum = 100;BA.debugLine="etCust.Text = \"The editbox now accepts only HEX";
mostCurrent._etcust.setText((Object)("The editbox now accepts only HEX-numbers & four cursor keys & a shift-key"));
 break;
case 3:
 //BA.debugLineNum = 102;BA.debugLine="etCust.Text = \"The editbox now accepts some spe";
mostCurrent._etcust.setText((Object)("The editbox now accepts some special characters and has longpress-popups"));
 break;
case 4:
 //BA.debugLineNum = 104;BA.debugLine="etCust.Text = \"The editbox now accepts all char";
mostCurrent._etcust.setText((Object)("The editbox now accepts all characters from the android standard keyboard"));
 break;
case 5:
 //BA.debugLineNum = 106;BA.debugLine="etCust.Text = \"This editbox was never registere";
mostCurrent._etcust.setText((Object)("This editbox was never registered and accepts all ASCII text"));
 break;
}
;
 //BA.debugLineNum = 108;BA.debugLine="End Sub";
return "";
}
}
